package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type ShowNetworkSegmentRangeDetailsLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewShowNetworkSegmentRangeDetailsLogic(ctx context.Context, svcCtx *svc.ServiceContext) *ShowNetworkSegmentRangeDetailsLogic {
	return &ShowNetworkSegmentRangeDetailsLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *ShowNetworkSegmentRangeDetailsLogic) ShowNetworkSegmentRangeDetails(req *types.ShowNetworkSegmentRangeDetailsReq) (resp *types.ShowNetworkSegmentRangeDetailsResp, err error) {
	// todo: add your logic here and delete this line
	ShowNetworkSegmentRangeDetailsReq := &openstack.ShowNetworkSegmentRangeDetailsReq{}
	err = copier.CopyWithOption(ShowNetworkSegmentRangeDetailsReq, req, copier.Option{Converters: utils.Converters})
	ShowNetworkSegmentRangeDetailsResp, err := l.svcCtx.OpenstackRpc.ShowNetworkSegmentRangeDetails(l.ctx, ShowNetworkSegmentRangeDetailsReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&ShowNetworkSegmentRangeDetailsResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &ShowNetworkSegmentRangeDetailsResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
